<template>
  <NavHeader></NavHeader>
  <PageTitle>Latest messages</PageTitle>
  <PlayerMessage
    v-for="player in players"
    :key="player.id"
    :player="player"
    :id="id"
  ></PlayerMessage>
  <form class="sendMessage" @submit.prevent="send" novalidate>
    <FormField
      id="message"
      inputType="text"
      v-model.trim="content"
      :required="true"
    ></FormField>
    <div class="buttons">
      <ActionButton type="submit">Send to all players</ActionButton>
    </div>
  </form>
</template>

<script>
import NavHeader from "./organisms/NavHeader.vue";
import PageTitle from "./atoms/PageTitle.vue";
import PlayerMessage from "./molecules/PlayerMessage.vue";
import axios from "axios";
import store from "../store/auth";
import FormField from "./molecules/FormField.vue";
import ActionButton from "./atoms/ActionButton.vue";

export default {
  components: { NavHeader, PageTitle, PlayerMessage, FormField, ActionButton },
  data() {
    return {
      players: [],
    };
  },
  props: {
    id: {
      validator(value) {
        return /([0-9])/.test(value);
      },
    },
  },
  async created() {
    store.commit("general/setLoading", true);
    //await this.getGames();
    await this.getLatestMessages();
    document.title = "Latest messages";
    store.commit("general/setLoading", false);
  },
  methods: {
    async getLatestMessages() {
      this.players = (
        await axios.get(`/api/games/${this.id}/messages/latest`)
      ).data.data;
      return;
    },
    async send() {
      await axios.post(`api/games/${this.id}/messages/send`, {
        content: this.content,
        receiver: "allPlayers",
      });
      this.$router.go();
    },
  },
};
</script>

<style lang="scss">
.playerMessage p {
  color: black;
}

.sendMessage {
  display: flex;
  flex-direction: row;
  justify-content: space-evenly;
  width: 80%;
  margin: auto;

  .FormField {
    width: 80%;
    margin: 0;
  }
  .buttons .actionButton {
    width: 5rem;
    margin-top: 0.7rem;
  }
}
</style>
